/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateMutableDataIntegrations type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateMutableDataIntegrations{}

// CxTemplateMutableDataIntegrations struct for CxTemplateMutableDataIntegrations
type CxTemplateMutableDataIntegrations struct {
	VynamicCoupons *bool `json:"vynamic_coupons,omitempty"`
	VynamicCrm *bool `json:"vynamic_crm,omitempty"`
	AnybillReceipt *bool `json:"anybill_receipt,omitempty"`
	PaypalPayments *bool `json:"paypal_payments,omitempty"`
	UnzerPayments *bool `json:"unzer_payments,omitempty"`
	InsignDocuments *bool `json:"insign_documents,omitempty"`
	PolyprintNfcCard *bool `json:"polyprint_nfc_card,omitempty"`
}

// NewCxTemplateMutableDataIntegrations instantiates a new CxTemplateMutableDataIntegrations object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateMutableDataIntegrations() *CxTemplateMutableDataIntegrations {
	this := CxTemplateMutableDataIntegrations{}
	return &this
}

// NewCxTemplateMutableDataIntegrationsWithDefaults instantiates a new CxTemplateMutableDataIntegrations object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateMutableDataIntegrationsWithDefaults() *CxTemplateMutableDataIntegrations {
	this := CxTemplateMutableDataIntegrations{}
	return &this
}

// GetVynamicCoupons returns the VynamicCoupons field value if set, zero value otherwise.
func (o *CxTemplateMutableDataIntegrations) GetVynamicCoupons() bool {
	if o == nil || IsNil(o.VynamicCoupons) {
		var ret bool
		return ret
	}
	return *o.VynamicCoupons
}

// GetVynamicCouponsOk returns a tuple with the VynamicCoupons field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableDataIntegrations) GetVynamicCouponsOk() (*bool, bool) {
	if o == nil || IsNil(o.VynamicCoupons) {
		return nil, false
	}
	return o.VynamicCoupons, true
}

// HasVynamicCoupons returns a boolean if a field has been set.
func (o *CxTemplateMutableDataIntegrations) HasVynamicCoupons() bool {
	if o != nil && !IsNil(o.VynamicCoupons) {
		return true
	}

	return false
}

// SetVynamicCoupons gets a reference to the given bool and assigns it to the VynamicCoupons field.
func (o *CxTemplateMutableDataIntegrations) SetVynamicCoupons(v bool) {
	o.VynamicCoupons = &v
}

// GetVynamicCrm returns the VynamicCrm field value if set, zero value otherwise.
func (o *CxTemplateMutableDataIntegrations) GetVynamicCrm() bool {
	if o == nil || IsNil(o.VynamicCrm) {
		var ret bool
		return ret
	}
	return *o.VynamicCrm
}

// GetVynamicCrmOk returns a tuple with the VynamicCrm field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableDataIntegrations) GetVynamicCrmOk() (*bool, bool) {
	if o == nil || IsNil(o.VynamicCrm) {
		return nil, false
	}
	return o.VynamicCrm, true
}

// HasVynamicCrm returns a boolean if a field has been set.
func (o *CxTemplateMutableDataIntegrations) HasVynamicCrm() bool {
	if o != nil && !IsNil(o.VynamicCrm) {
		return true
	}

	return false
}

// SetVynamicCrm gets a reference to the given bool and assigns it to the VynamicCrm field.
func (o *CxTemplateMutableDataIntegrations) SetVynamicCrm(v bool) {
	o.VynamicCrm = &v
}

// GetAnybillReceipt returns the AnybillReceipt field value if set, zero value otherwise.
func (o *CxTemplateMutableDataIntegrations) GetAnybillReceipt() bool {
	if o == nil || IsNil(o.AnybillReceipt) {
		var ret bool
		return ret
	}
	return *o.AnybillReceipt
}

// GetAnybillReceiptOk returns a tuple with the AnybillReceipt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableDataIntegrations) GetAnybillReceiptOk() (*bool, bool) {
	if o == nil || IsNil(o.AnybillReceipt) {
		return nil, false
	}
	return o.AnybillReceipt, true
}

// HasAnybillReceipt returns a boolean if a field has been set.
func (o *CxTemplateMutableDataIntegrations) HasAnybillReceipt() bool {
	if o != nil && !IsNil(o.AnybillReceipt) {
		return true
	}

	return false
}

// SetAnybillReceipt gets a reference to the given bool and assigns it to the AnybillReceipt field.
func (o *CxTemplateMutableDataIntegrations) SetAnybillReceipt(v bool) {
	o.AnybillReceipt = &v
}

// GetPaypalPayments returns the PaypalPayments field value if set, zero value otherwise.
func (o *CxTemplateMutableDataIntegrations) GetPaypalPayments() bool {
	if o == nil || IsNil(o.PaypalPayments) {
		var ret bool
		return ret
	}
	return *o.PaypalPayments
}

// GetPaypalPaymentsOk returns a tuple with the PaypalPayments field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableDataIntegrations) GetPaypalPaymentsOk() (*bool, bool) {
	if o == nil || IsNil(o.PaypalPayments) {
		return nil, false
	}
	return o.PaypalPayments, true
}

// HasPaypalPayments returns a boolean if a field has been set.
func (o *CxTemplateMutableDataIntegrations) HasPaypalPayments() bool {
	if o != nil && !IsNil(o.PaypalPayments) {
		return true
	}

	return false
}

// SetPaypalPayments gets a reference to the given bool and assigns it to the PaypalPayments field.
func (o *CxTemplateMutableDataIntegrations) SetPaypalPayments(v bool) {
	o.PaypalPayments = &v
}

// GetUnzerPayments returns the UnzerPayments field value if set, zero value otherwise.
func (o *CxTemplateMutableDataIntegrations) GetUnzerPayments() bool {
	if o == nil || IsNil(o.UnzerPayments) {
		var ret bool
		return ret
	}
	return *o.UnzerPayments
}

// GetUnzerPaymentsOk returns a tuple with the UnzerPayments field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableDataIntegrations) GetUnzerPaymentsOk() (*bool, bool) {
	if o == nil || IsNil(o.UnzerPayments) {
		return nil, false
	}
	return o.UnzerPayments, true
}

// HasUnzerPayments returns a boolean if a field has been set.
func (o *CxTemplateMutableDataIntegrations) HasUnzerPayments() bool {
	if o != nil && !IsNil(o.UnzerPayments) {
		return true
	}

	return false
}

// SetUnzerPayments gets a reference to the given bool and assigns it to the UnzerPayments field.
func (o *CxTemplateMutableDataIntegrations) SetUnzerPayments(v bool) {
	o.UnzerPayments = &v
}

// GetInsignDocuments returns the InsignDocuments field value if set, zero value otherwise.
func (o *CxTemplateMutableDataIntegrations) GetInsignDocuments() bool {
	if o == nil || IsNil(o.InsignDocuments) {
		var ret bool
		return ret
	}
	return *o.InsignDocuments
}

// GetInsignDocumentsOk returns a tuple with the InsignDocuments field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableDataIntegrations) GetInsignDocumentsOk() (*bool, bool) {
	if o == nil || IsNil(o.InsignDocuments) {
		return nil, false
	}
	return o.InsignDocuments, true
}

// HasInsignDocuments returns a boolean if a field has been set.
func (o *CxTemplateMutableDataIntegrations) HasInsignDocuments() bool {
	if o != nil && !IsNil(o.InsignDocuments) {
		return true
	}

	return false
}

// SetInsignDocuments gets a reference to the given bool and assigns it to the InsignDocuments field.
func (o *CxTemplateMutableDataIntegrations) SetInsignDocuments(v bool) {
	o.InsignDocuments = &v
}

// GetPolyprintNfcCard returns the PolyprintNfcCard field value if set, zero value otherwise.
func (o *CxTemplateMutableDataIntegrations) GetPolyprintNfcCard() bool {
	if o == nil || IsNil(o.PolyprintNfcCard) {
		var ret bool
		return ret
	}
	return *o.PolyprintNfcCard
}

// GetPolyprintNfcCardOk returns a tuple with the PolyprintNfcCard field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateMutableDataIntegrations) GetPolyprintNfcCardOk() (*bool, bool) {
	if o == nil || IsNil(o.PolyprintNfcCard) {
		return nil, false
	}
	return o.PolyprintNfcCard, true
}

// HasPolyprintNfcCard returns a boolean if a field has been set.
func (o *CxTemplateMutableDataIntegrations) HasPolyprintNfcCard() bool {
	if o != nil && !IsNil(o.PolyprintNfcCard) {
		return true
	}

	return false
}

// SetPolyprintNfcCard gets a reference to the given bool and assigns it to the PolyprintNfcCard field.
func (o *CxTemplateMutableDataIntegrations) SetPolyprintNfcCard(v bool) {
	o.PolyprintNfcCard = &v
}

func (o CxTemplateMutableDataIntegrations) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateMutableDataIntegrations) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.VynamicCoupons) {
		toSerialize["vynamic_coupons"] = o.VynamicCoupons
	}
	if !IsNil(o.VynamicCrm) {
		toSerialize["vynamic_crm"] = o.VynamicCrm
	}
	if !IsNil(o.AnybillReceipt) {
		toSerialize["anybill_receipt"] = o.AnybillReceipt
	}
	if !IsNil(o.PaypalPayments) {
		toSerialize["paypal_payments"] = o.PaypalPayments
	}
	if !IsNil(o.UnzerPayments) {
		toSerialize["unzer_payments"] = o.UnzerPayments
	}
	if !IsNil(o.InsignDocuments) {
		toSerialize["insign_documents"] = o.InsignDocuments
	}
	if !IsNil(o.PolyprintNfcCard) {
		toSerialize["polyprint_nfc_card"] = o.PolyprintNfcCard
	}
	return toSerialize, nil
}

type NullableCxTemplateMutableDataIntegrations struct {
	value *CxTemplateMutableDataIntegrations
	isSet bool
}

func (v NullableCxTemplateMutableDataIntegrations) Get() *CxTemplateMutableDataIntegrations {
	return v.value
}

func (v *NullableCxTemplateMutableDataIntegrations) Set(val *CxTemplateMutableDataIntegrations) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateMutableDataIntegrations) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateMutableDataIntegrations) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateMutableDataIntegrations(val *CxTemplateMutableDataIntegrations) *NullableCxTemplateMutableDataIntegrations {
	return &NullableCxTemplateMutableDataIntegrations{value: val, isSet: true}
}

func (v NullableCxTemplateMutableDataIntegrations) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateMutableDataIntegrations) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


